%The following calculates Signal to background ratios based on the number
%of bits in an MLS pattern

clear all
close all

%create an array with the number of bits for the MLS
num_bits_array = [10 20 30 40 50 60 70 80 90 100];
vec_to_plot = zeros(1,length(num_bits_array));

%Loop through for each number of bits for the MLS
figure
for variable = 1:length(num_bits_array)
    fprintf('%i\n',variable)
    num_bits = num_bits_array(variable);
    %For each bit size MLS, run correlation analysis that determines the
    %signal to background ratios at various noise levels
    Simulation_Bit_SNR_FINAL_V3
    vec_to_plot(variable,1:length(mean(SNR_bits_matrix))) = mean(SNR_bits_matrix);
   plot(noise_level,vec_to_plot(variable,1:end),'Color',[variable/10,variable/10,1-variable/10],'LineWidth',2)
   
   hold on
end

legend('10','20','30','40','50','60','70','80','90','100')
[m,n] = size(vec_to_plot);

%Convert everything to dB
log_conversion_vec = 20*log10(vec_to_plot);

%plot the vectors
figure
for variable = 1:length(num_bits_array)
   plot(noise_level,smooth(log_conversion_vec(variable,1:end),7),'Color',[variable/10,variable/10,1-variable/10],'LineWidth',2)
   hold on
end

legend('10','20','30','40','50','60','70','80','90','100')


%Create cutlines at various segments to examine how the signal to noise changes with respect to the bit length 
zero_dB_data = [10	15.04598464
20	17.23674894
30	18.38987531
40	19.65995819
50	20.7912205
60	21.19621065
70	21.64628649
80	22.14595573
90	23.04038898
100	23.31369804
];

figure
plot(zero_dB_data(:,1),zero_dB_data(:,2))
hold on
plot(zero_dB_data(:,1),zero_dB_data(:,2),'*','MarkerSize',15)

xlabel('Number of Bits in MLS')
ylabel('Correlation Signal to Background [dB]')


