%The following calculates Signal to background ratios based on the number
%of bits in an MLS pattern
logbase2pow = ceil(log2(500));
MLS_Seq = mseq(2,logbase2pow,0,0);
MLS_seq = MLS_Seq(1:num_bits);

x = 1:length(MLS_seq);
v = MLS_seq;

xq = 1:.1:length(MLS_seq);
vq2 = interp1(x,v,xq,'nearest');

Signal_Mat = zeros(7,1280);

%create a matrix with beads starting at different segments
Signal_Mat(1,1:length(vq2)) = vq2;
Original_signal = Signal_Mat(1,:);

%These are the separate noise intervals we will loop through
noise_level = [-50:1:50]; %in dB

%since we know exactly where the correlation peak should occur based on the
%size of the 
switch num_bits
    case 10
        index_i = 1091;
    case 20
        index_i = 1191;
    case 30
        index_i = 1291;
    case 40
        index_i = 1391;  
    case 50
        index_i = 1491;
    case 60
        index_i = 1591;
    case 70
        index_i = 1691;
    case 80
        index_i = 1791;          
    case 90
        index_i = 1891;
    case 100
        index_i = 1991;
end       


%Start loop through 500 times for each number of MLS bit size
i = 1;

for j = 1:500
    
    %Create two separate signals that have MLS patterns from different
    %segments of the same output from mseq
     MLS_seq = mseq(2,logbase2pow,0,0);
     MLS_seq2 = MLS_seq(1+200:num_bits+200);
     MLS_seq = MLS_seq(1:num_bits);
     
     %for each of the nois levels, loop through to find the ratio between
     %the signal and background
for i = 1:length(noise_level)
    %interpolate both signals and add spacers at the end
    x = 1:length(MLS_seq);
    v = MLS_seq;
    xq = 1:.1:length(MLS_seq);
    vq2 = interp1(x,v,xq,'nearest');


    x_2 = 1:length(MLS_seq2);
    v_2 = MLS_seq2;
    xq_2 = 1:.1:length(MLS_seq2);
    vq2_2 = interp1(x_2,v_2,xq_2,'nearest');
    signal = vq2;
    signal = [zeros(1,500) signal zeros(1,500)];

    %take correlations after adding noise
    signal = awgn(signal,noise_level(i));
    signal2= signal;
    corr_vector = xcorr(vq2,signal);
    %the first correlatoin is with the actual signal compared to the
    %background
    
    %the second correlation below is a correlation with an empty channel
    %that has the same level of noise added to the system
    signal = zeros(1,length(signal));
    signal = awgn(signal,noise_level(i));

    corr_vector_empty = xcorr(vq2,signal);
    corr_vector = [zeros(1,500) corr_vector zeros(1,500)];
    corr_vector_empty = [zeros(1,500) corr_vector_empty zeros(1,500)];

    %define a peak width based on the correlation peak width we calculated
    %from simulation.
    peak_width = 20;

    %take a ratio between the correlation of a vector that contains the
    %signal and the region around the empty vector; a larger region is used
    %for the empty vector to avoid any fluctions that arise 
    SNR_vs_bits(i) = rms(corr_vector((index_i-peak_width):(index_i+peak_width)))/rms(corr_vector_empty((index_i-peak_width):(index_i+peak_width)));

end
    SNR_bits_matrix(j,1:length(SNR_vs_bits)) = SNR_vs_bits;
end
