%pick number of bits for MLS and generate signal
num_bits = 63;
logbase2pow = ceil(log2(num_bits));%get base power of 2 for number of bits desired
MLS_seq = mseq(2,logbase2pow,0,0);
MLS_seq = MLS_seq(1:num_bits);
x = 1:length(MLS_seq);
v = MLS_seq;
close all
xq = 1:.1:length(MLS_seq);
vq2 = 10*(interp1(x,v,xq,'nearest')+1);

%replace vq2 with a DC signal of same magnitude
vq2 = ones(1,621)*20;

%preallocate a signal matrix
Signal_Mat = zeros(27,1920);

%add droplets randomly into segments that are atleast two droplet diameters
%apart; some code was borrowed from the following:
% http://stackoverflow.com/questions/31971344/generating-random-sequence-with-minimum-distance-between-elements-matlab

real_locations_droplets = zeros(1,27);
L=1280/6;  %length of interval
d=6/6;   %minimum distance
N=27;   %number of points
E=L-(N-1)*d;  %excess space for points

%generate N+1 random values; 
Ro=rand(N+1,1);     %random vector
%normalize so that the extra space is consumed
% extra value is the amount of extra space "unused"
Rn=E*Ro(1:N)/sum(Ro); %normalize

%spacing of points
S=d*ones(N,1)+Rn;  

%location of points, adjusted to "start" at 0
P=cumsum(S)-1;
P= floor(P);
ix = randperm(length(P));
Pshuffled = P(ix);
Pshuffled=Pshuffled*6;

%place the droplets at different starting points
for i = 1:num_droplets
   number_toshift = Pshuffled(i);      
  Signal_Mat(i,1+number_toshift:number_toshift+length(vq2)) = vq2;
  real_locations_droplets(i) =1+number_toshift;
end
real_locations_droplets_bef = real_locations_droplets;
%add noise to the signal
snr = -10;
for i = 1:num_droplets
    Signal_Mat(i,:) = awgn(Signal_Mat(i,:),snr);
end

%start adding the droplets such that they overlap
Signal = zeros(1,length(Signal_Mat(1,:)));
for i = 1:27
    Signal = Signal + Signal_Mat(i,:);
end
%take a correlation from the expected to the signal that contains all the
%droplet summations
corr_vector = xcorr(vq2,Signal);
actual_vector_that_matters = (fliplr(corr_vector(1:1920))); %index properly

%normalize the vector
actual_vector_that_matters=actual_vector_that_matters/max(actual_vector_that_matters);
%the threshold is set from earlier. the threshold value can be changed to
%get differnet amounts of counted droplets
[pks,locs] = findpeaks(actual_vector_that_matters,'MinPeakDistance',6,'MinPeakHeight',threshold2);
locs_bef = locs;
threshold_line_x = 1:20:length(actual_vector_that_matters);
threshold_line_y = zeros(1,length(threshold_line_x))+threshold2;


%true positives are where locs match the locs of where droplets are placed
%false positives are when locs show up that are no in the original list
%false negatives are when a peak is supposed to be there but nothing shows
%up

%we already know where the droplets were initially placed; so find those
%locations first and sort
locs2 = locs;
real_locations_droplets2 =sort(real_locations_droplets(real_locations_droplets~=0))';

%this is the known number of droplets we placed randomly
positives = num_droplets;

%preallocate
true_pos = 0;
locs =locs(locs~=0);
real_locations_droplets =real_locations_droplets(real_locations_droplets~=0);

%another way to measure this is to look at the differences between where
%droplets were placed and the distances between peaks incase the
%correlation is off from the exact location; both can be used to affirm
%positive droplets
diff_locs = diff(locs2);
diff_reals = diff(real_locations_droplets2);

diff_locs2 = diff_locs;
diff_reals2 = diff_reals;

%for each of the locations found in corrrelation, compare it to the list of
%locations where droplets were randomly placed in simulation. If a droplet
%location matches that of where it was placed, add a true positive.
for i = 1:length(locs)
    for j = 1:length(real_locations_droplets)
        if locs(i) == real_locations_droplets(j)
            true_pos = true_pos +1;
            real_locations_droplets(j) = 5000;
            locs(i) = 0;
        end
    end
end

for i = 1:length(real_locations_droplets)
    if real_locations_droplets(i) == 5000;
        real_locations_droplets(i) = 0;
    end
end

true_pos2 = 0;
for i = 1:length(diff_locs)
    for j = 1:length(diff_reals)

            if diff_locs(i) == diff_reals(j)
            true_pos2 = true_pos2 +1;
            diff_reals(j) = 5000;
            diff_locs(i) = 0;
        end
    end
end


for i = 1:length(diff_reals)
    if diff_reals(i) == 5000;
        diff_reals(i) = 0;
    end
end


%false positives are locations that were found in correlation but were not
%locations were droplets were placed
true_pos ;
false_neg = nnz(real_locations_droplets);
false_pos = nnz(locs);

     true_pos2 ;
false_neg2 = nnz(diff_reals);
false_pos2 = nnz(diff_locs);
