%pick number of bits for MLS and generate signal
num_bits = 63;
logbase2pow = ceil(log2(num_bits));%get base power of 2 for number of bits desired
MLS_seq = mseq(2,logbase2pow,0,0);
MLS_seq = MLS_seq(1:num_bits);
x = 1:length(MLS_seq);
v = MLS_seq;
close all
xq = 1:.1:length(MLS_seq);
vq2 = 10*(interp1(x,v,xq,'nearest')+1);

%preallocate a signal matrix
Signal_Mat = zeros(27,1920);

%add droplets randomly into segments that are atleast two droplet diameters
%apart; some code was borrowed from the following:

Signal_Mat(1,401:400+length(vq2)) = vq2;
Signal_Mat(2,401+distnace:400+distnace+length(vq2)) = vq2;
real_locations_droplets = [401 401+distnace];

%place the droplets at different starting points
% for i = 1:num_droplets
%    number_toshift = Pshuffled(i);      
%   Signal_Mat(i,1+number_toshift:number_toshift+length(vq2)) = vq2;
%   real_locations_droplets(i) =1+number_toshift;
% end

%add noise to the signal
snr = -10;
for i = 1:2
    Signal_Mat(i,:) = awgn(Signal_Mat(i,:),snr);
end

%start adding the droplets such that they overlap
Signal = zeros(1,length(Signal_Mat(1,:)));
for i = 1:2
    Signal = Signal + Signal_Mat(i,:);
end
%take a correlation from the expected to the signal that contains all the
%droplet summations
corr_vector = xcorr(vq2,Signal);

%filter out DC components
Fs = 1920;
half_freq = Fs/2;
notch_freq_filter =1;
low_freq_filt = 2;
smoothing_factor = 2;
w0=notch_freq_filter/half_freq;
[num,den]=iirnotch(w0,w0/35,-45);
[a,b]=butter(2,low_freq_filt/half_freq,'high');
 
y=filter(num,den,corr_vector);
yfil=filtfilt(a,b,y); 
ysm=smooth(yfil,smoothing_factor);  

%plot a portion where the vectors overlap completely
actual_vector_that_matters = abs(ysm(640:1920+640));
actual_vector_that_matters = flipud((ysm(1:1920)));

%normalize the vector
actual_vector_that_matters=actual_vector_that_matters/max(actual_vector_that_matters);
%the threshold is set from earlier. the threshold value can be changed to
%get differnet amounts of counted droplets
[pks,locs] = findpeaks(actual_vector_that_matters,'MinPeakDistance',6,'MinPeakHeight',threshold2);

threshold_line_x = 1:20:length(actual_vector_that_matters);
threshold_line_y = zeros(1,length(threshold_line_x))+threshold2;


%true positives are where locs match the locs of where droplets are placed
%false positives are when locs show up that are no in the original list
%false negatives are when a peak is supposed to be there but nothing shows
%up

%we already know where the droplets were initially placed; so find those
%locations first and sort
locs2 = locs;
real_locations_droplets2 =sort(real_locations_droplets(real_locations_droplets~=0))';

%this is the known number of droplets we placed randomly
positives = 2;

%preallocate
true_pos = 0;
locs =locs(locs~=0);
real_locations_droplets =real_locations_droplets(real_locations_droplets~=0);

%another way to measure this is to look at the differences between where
%droplets were placed and the distances between peaks incase the
%correlation is off from the exact location; both can be used to affirm
%positive droplets
diff_locs = diff(locs2);
diff_reals = diff(real_locations_droplets2);

diff_locs2 = diff_locs;
diff_reals2 = diff_reals;

%for each of the locations found in corrrelation, compare it to the list of
%locations where droplets were randomly placed in simulation. If a droplet
%location matches that of where it was placed, add a true positive.
for i = 1:length(locs)
    for j = 1:length(real_locations_droplets)
        if locs(i) == real_locations_droplets(j)
            true_pos = true_pos +1;
            real_locations_droplets(j) = 5000;
            locs(i) = 0;
        end
    end
end

for i = 1:length(real_locations_droplets)
    if real_locations_droplets(i) == 5000;
        real_locations_droplets(i) = 0;
    end
end

true_pos2 = 0;
for i = 1:length(diff_locs)
    for j = 1:length(diff_reals)

            if diff_locs(i) == diff_reals(j)
            true_pos2 = true_pos2 +1;
            diff_reals(j) = 5000;
            diff_locs(i) = 0;
        end
    end
end


for i = 1:length(diff_reals)
    if diff_reals(i) == 5000;
        diff_reals(i) = 0;
    end
end


%false positives are locations that were found in correlation but were not
%locations were droplets were placed
true_pos ;
false_neg = nnz(real_locations_droplets);
false_pos = nnz(locs);

     true_pos2 ;
false_neg2 = nnz(diff_reals);
false_pos2 = nnz(diff_locs);
