%begins a 2d correlation for the input signal and the selected expected signal based on the phase
%finds the best matching velocity for the given phase after searching through the 2d map


%To vary the range of velocities to scan, this variable can be altered.
%Preallocating the expected signal improves computational time.
Signal_Mat(:,:) = All_Interpolated_Masks(phase,:,:);
ma = Signal_Mat;
out8=xcorr2(sig,ma);
[mat_a mat_b] = size(out8);
%store the length of each MLS for different velocities to normalize later
flipped_vec = fliplr(lengths_vector);
out8_new = zeros(mat_a,mat_b);

%take correlatoins and normalize by length of the mask
for i = 1:mat_a
        out8_new(i,1:mat_b) = out8(i,:)/flipped_vec(i);
end

%select the velocity that generates the largest peak. 
[M,N] = find(out8_new==max(max(out8_new)));
Max_out = out8_new(M(1),:);
 
%Filter to get rid of DC effects    
Fs = 1920;
half_freq = Fs/2;
notch_freq_filter =1;
low_freq_filt = 1;
smoothing_factor = 1;
w0=notch_freq_filter/half_freq;
[num,den]=iirnotch(w0,w0/35,-45);
[a,b]=butter(2,low_freq_filt/half_freq,'high'); %remove low frequency components
 
y=filter(num,den,Max_out);
yfil=filtfilt(a,b,y); 
ysm=smooth(yfil,smoothing_factor);  
 
FINAL_CORR_VECTOR = (ysm);